'Sparrow_Sunlight.bas
'Warning after two hours of bright sunshine
'Red LED as light sensor

$regfile = "attiny13.dat"
$crystal = 1200000
Baud = 9600
$hwstack = 8
$swstack = 4
$framesize = 4

Dim D As Word
Dim Dummy As Word
Dim N As Byte
Dim Suntime As Word
Open "comb.1:9600,8,n,1,INVERTED" For Output As #1


Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc                                                   'Ref 1,1 V
Ddrb.4 = 1
Portb.4 = 0
Suntime = 0

Do
  D = 0
  For N = 1 To 50
     Dummy = Getadc(2)                                      'discharge
     Waitus 2
     D = D + Getadc(3)                                      'LED voltage
  Next N
  D = D / 50
  If D > 1020 Then Suntime = Suntime + 1
  Wait 1
  If Suntime > 7200 Then                                    '2 hours maximum
    Ddrb.3 = 1
    Portb.3 = 1                                             'LED red
    Ddrb.1 = 1
    Portb.1 = 1                                             'LED green
    Do
    Loop
  End If
  Print #1 , D                                              'debugging only
Loop

End